## frobby 0.9.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(frobby VERSION 0.9.6 LANGUAGES CXX)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

option(WITH_MPIR "Build with MPIR or not" off)

if(WITH_MPIR)
  find_package(MPIR 3.0.0 REQUIRED)
  set(GMP_LIBRARIES ${MPIR_LIBRARIES})
  set(GMP_INCLUDE_DIRS ${MPIR_INCLUDE_DIRS})
else()
  find_package(GMP 6.0.0 REQUIRED)
endif()

add_compile_options(
  -DPACKAGE_NAME="${PROJECT_NAME}"
  -DPACKAGE_TARNAME="${PROJECT_NAME}"
  -DPACKAGE_VERSION="${PROJECT_VERSION}"
  -DPACKAGE_STRING="${PROJECT_NAME} ${PROJECT_VERSION}"
  -DPACKAGE_BUGREPORT=""
  -DPACKAGE_URL=""
  -DPACKAGE="${PROJECT_NAME}"
  -DVERSION="${PROJECT_VERSION}"
  -Wno-uninitialized -Wno-unused-parameter
  )

add_library(frobby STATIC
  src/main.cpp
  src/display.cpp
  src/dynamicFrobeniusAlgorithm.cpp
  src/error.cpp
  src/fourti2.cpp
  src/fplllIO.cpp
  src/frobby.cpp
  src/intersect.cpp
  src/lattice.cpp
  src/randomDataGenerators.cpp
  src/stdinc.h

  src/Action.cpp
  src/ActionPrinter.cpp
  src/AlexanderDualAction.cpp
  src/AnalyzeAction.cpp
  src/Arena.cpp
  src/AssociatedPrimesAction.cpp
  src/BigIdeal.cpp
  src/BigIntVector.cpp
  src/BigPolynomial.cpp
  src/BigTermConsumer.cpp
  src/BigTermRecorder.cpp
  src/BigattiBaseCase.cpp
  src/BigattiFacade.cpp
  src/BigattiHilbertAlgorithm.cpp
  src/BigattiParams.cpp
  src/BigattiPivotStrategy.cpp
  src/BigattiState.cpp
  src/BoolParameter.cpp
  src/CanonicalCoefTermConsumer.cpp
  src/CanonicalTermConsumer.cpp
  src/CliParams.cpp
  src/CoCoA4IOHandler.cpp
  src/CoefBigTermConsumer.cpp
  src/CoefBigTermRecorder.cpp
  src/CoefTermConsumer.cpp
  src/ColumnPrinter.cpp
  src/CommonParams.cpp
  src/CommonParamsHelper.cpp
  src/CountingIOHandler.cpp
  src/DataType.cpp
  src/DebugAllocator.cpp
  src/DebugStrategy.cpp
  src/DecomRecorder.cpp
  src/Deformer.cpp
  src/DimensionAction.cpp
  src/DynamicFrobeniusAction.cpp
  src/DynamicFrobeniusFacade.cpp
  src/EulerAction.cpp
  src/EulerState.cpp
  src/Facade.cpp
  src/Fourti2IOHandler.cpp
  src/FrobbyStringStream.cpp
  src/FrobeniusAction.cpp
  src/GenerateDataFacade.cpp
  src/GenerateFrobeniusAction.cpp
  src/GenerateIdealAction.cpp
  src/HashPolynomial.cpp
  src/HelpAction.cpp
  src/HilbertAction.cpp
  src/HilbertBasecase.cpp
  src/HilbertIndependenceConsumer.cpp
  src/HilbertSlice.cpp
  src/HilbertStrategy.cpp
  src/IOFacade.cpp
  src/IOHandler.cpp
  src/IOHandlerCommon.cpp
  src/IOHandlerImpl.cpp
  src/IOParameters.cpp
  src/Ideal.cpp
  src/IdealComparator.cpp
  src/IdealConsolidator.cpp
  src/IdealFacade.cpp
  src/IdealFactory.cpp
  src/IdealOrderer.cpp
  src/IdealTree.cpp
  src/IdealWriter.cpp
  src/IndependenceSplitter.cpp
  src/InputConsumer.cpp
  src/IntegerParameter.cpp
  src/IntersectFacade.cpp
  src/IntersectionAction.cpp
  src/IrreducibleDecomAction.cpp
  src/IrreducibleIdealSplitter.cpp
  src/LatticeAlgs.cpp
  src/LatticeAnalyzeAction.cpp
  src/LatticeFacade.cpp
  src/LatticeFormatAction.cpp
  src/LocalArray.cpp
  src/Macaulay2IOHandler.cpp
  src/Matrix.cpp
  src/MaximalStandardAction.cpp
  src/Minimizer.cpp
  src/MonosIOHandler.cpp
  src/MsmSlice.cpp
  src/MsmStrategy.cpp
  src/NameFactory.cpp
  src/NewMonosIOHandler.cpp
  src/NullCoefTermConsumer.cpp
  src/NullIOHandler.cpp
  src/NullTermConsumer.cpp
  src/ObjectCache.cpp
  src/OptimizeAction.cpp
  src/OptimizeStrategy.cpp
  src/Parameter.cpp
  src/ParameterGroup.cpp
  src/Partition.cpp
  src/PivotEulerAlg.cpp
  src/PivotStrategy.cpp
  src/PolyTransformAction.cpp
  src/PolyWriter.cpp
  src/Polynomial.cpp
  src/PolynomialConsolidator.cpp
  src/PolynomialFacade.cpp
  src/PolynomialFactory.cpp
  src/PrimaryDecomAction.cpp
  src/Projection.cpp
  src/RawSquareFreeIdeal.cpp
  src/RawSquareFreeTerm.cpp
  src/SatBinomConsumer.cpp
  src/SatBinomIdeal.cpp
  src/SatBinomRecorder.cpp
  src/Scanner.cpp
  src/ScarfFacade.cpp
  src/ScarfHilbertAlgorithm.cpp
  src/ScarfParams.cpp
  src/SingularIOHandler.cpp
  src/SizeMaxIndepSetAlg.cpp
  src/Slice.cpp
  src/SliceFacade.cpp
  src/SliceLikeParams.cpp
  src/SliceParameters.cpp
  src/SliceParams.cpp
  src/SliceStrategy.cpp
  src/SliceStrategyCommon.cpp
  src/SplitStrategy.cpp
  src/SquareFreeIdeal.cpp
  src/StatisticsStrategy.cpp
  src/StringParameter.cpp
  src/Task.cpp
  src/TaskEngine.cpp
  src/Term.cpp
  src/TermConsumer.cpp
  src/TermExtra.cpp
  src/TermGrader.cpp
  src/TermPredicate.cpp
  src/TermTranslator.cpp
  src/TestAction.cpp
  src/Timer.cpp
  src/TotalDegreeCoefTermConsumer.cpp
  src/TransformAction.cpp
  src/TranslatingCoefTermConsumer.cpp
  src/TranslatingTermConsumer.cpp
  src/UniHashPolynomial.cpp
  src/VarNames.cpp
  src/VarSorter.cpp

  src/test/Test.cpp
  src/test/TestCase.cpp
  src/test/TestQualifier.cpp
  src/test/TestRunner.cpp
  src/test/TestSorter.cpp
  src/test/TestSuite.cpp
  src/test/TestVisitor.cpp
  src/test/asserts.cpp
  src/test/macroes.cpp
  )

target_link_libraries(frobby ${GMP_LIBRARIES})
target_include_directories(frobby PUBLIC
  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>
  $<INSTALL_INTERFACE:include>
  )
target_include_directories(frobby SYSTEM PUBLIC
  $<BUILD_INTERFACE:${GMP_INCLUDE_DIRS}>
  )

set_target_properties(frobby PROPERTIES PUBLIC_HEADER src/frobby.h)
install(TARGETS frobby LIBRARY DESTINATION lib)
install(FILES GPL-header COPYING DESTINATION licenses/frobby)

add_executable(frobby-executable src/main.cpp)
set_target_properties(frobby-executable PROPERTIES OUTPUT_NAME frobby)
target_link_libraries(frobby-executable frobby)
install(TARGETS frobby-executable)

include(CTest)
if(BUILD_TESTING)
  add_executable(frobby-tests
    src/ArenaTest.cpp
    src/IdealTest.cpp
    src/LibAlexanderDualTest.cpp
    src/LibAssociatedPrimesTest.cpp
    src/LibDimensionTest.cpp
    src/LibHilbertPoincareTest.cpp
    src/LibIrreducibleDecomTest.cpp
    src/LibMaxStdTest.cpp
    src/LibPrimaryDecomTest.cpp
    src/LibStdProgramTest.cpp
    src/LibTest.cpp
    src/MatrixTest.cpp
    src/OptimizeStrategyTest.cpp
    src/RawSquareFreeIdealTest.cpp
    src/RawSquareFreeTermTest.cpp
    src/TermGraderTest.cpp
    src/TermTest.cpp
    src/TermTranslatorTest.cpp
    )
  target_link_libraries(frobby-tests frobby)

  # TODO: see testing section in Makefile
  # add_test()
endif()

=== Makefile ===
# ***** Variables


# ========================
# >>>>>  GMP set-up  <<<<<
# ========================
# For GMP set **both**  GMP_INC_DIR  **and**  ldflags_for_gmp
# If you have a system installation of GMP with C++ support use next 2 lines:
# GMP_INC_DIR=
# ldflags_for_gmp=-lgmpxx -lgmp
GMP_INC_DIR=/usr/local/include
ldflags_for_gmp=-L/usr/local/lib -lgmpxx -lgmp

# shared library version
# bump if interfaces added, removed, or changed
FROBBY_CURRENT = 1
# bump at every release, set to 0 if any interfaces added, removed, or changed
FROBBY_REVISION = 1
# bump if interfaces added, set to 0 if removed or changed
FROBBY_AGE = 0
FROBBY_SOVERSION := $(shell expr $(FROBBY_CURRENT) - $(FROBBY_AGE))
FROBBY_VERSION := $(FROBBY_SOVERSION).$(FROBBY_AGE).$(FROBBY_REVISION)

rawSources := main.cpp Action.cpp IOParameters.cpp						\
  IrreducibleDecomAction.cpp fplllIO.cpp IOHandler.cpp fourti2.cpp		\
  randomDataGenerators.cpp MonosIOHandler.cpp BigIdeal.cpp				\
  TransformAction.cpp Macaulay2IOHandler.cpp NewMonosIOHandler.cpp		\
  HelpAction.cpp DynamicFrobeniusAction.cpp					\
  dynamicFrobeniusAlgorithm.cpp GenerateIdealAction.cpp					\
  GenerateFrobeniusAction.cpp intersect.cpp FrobeniusAction.cpp			\
  Facade.cpp IOFacade.cpp DynamicFrobeniusFacade.cpp					\
  GenerateDataFacade.cpp AnalyzeAction.cpp IdealFacade.cpp				\
  Parameter.cpp ParameterGroup.cpp IntegerParameter.cpp					\
  SliceParameters.cpp BoolParameter.cpp Scanner.cpp Partition.cpp		\
  StringParameter.cpp Term.cpp TermTranslator.cpp Timer.cpp				\
  VarNames.cpp LatticeFormatAction.cpp Ideal.cpp						\
  IntersectionAction.cpp IntersectFacade.cpp							\
  AssociatedPrimesAction.cpp MsmSlice.cpp IndependenceSplitter.cpp		\
  Projection.cpp MsmStrategy.cpp lattice.cpp LatticeFacade.cpp			\
  DecomRecorder.cpp TermGrader.cpp Fourti2IOHandler.cpp					\
  NullIOHandler.cpp Minimizer.cpp AlexanderDualAction.cpp frobby.cpp	\
  BigTermConsumer.cpp TranslatingTermConsumer.cpp HilbertAction.cpp		\
  HilbertSlice.cpp Polynomial.cpp CanonicalCoefTermConsumer.cpp			\
  HilbertStrategy.cpp Slice.cpp SliceStrategyCommon.cpp					\
  DebugStrategy.cpp OptimizeStrategy.cpp SliceFacade.cpp				\
  BigTermRecorder.cpp CoCoA4IOHandler.cpp SingularIOHandler.cpp			\
  TotalDegreeCoefTermConsumer.cpp BigPolynomial.cpp						\
  CoefBigTermRecorder.cpp PolyTransformAction.cpp VarSorter.cpp			\
  TermConsumer.cpp NullTermConsumer.cpp CoefTermConsumer.cpp			\
  NullCoefTermConsumer.cpp TranslatingCoefTermConsumer.cpp				\
  PolynomialFacade.cpp HilbertBasecase.cpp								\
  HilbertIndependenceConsumer.cpp SplitStrategy.cpp						\
  CanonicalTermConsumer.cpp StatisticsStrategy.cpp TestAction.cpp		\
  NameFactory.cpp error.cpp DebugAllocator.cpp FrobbyStringStream.cpp	\
  SliceStrategy.cpp PrimaryDecomAction.cpp IdealComparator.cpp			\
  IrreducibleIdealSplitter.cpp DataType.cpp IdealConsolidator.cpp		\
  CoefBigTermConsumer.cpp PolynomialConsolidator.cpp					\
  OptimizeAction.cpp MaximalStandardAction.cpp test/Test.cpp			\
  test/TestCase.cpp test/TestQualifier.cpp test/TestRunner.cpp			\
  test/TestSuite.cpp test/TestVisitor.cpp test/macroes.cpp				\
  test/asserts.cpp IdealFactory.cpp PolynomialFactory.cpp				\
  LatticeAnalyzeAction.cpp SatBinomIdeal.cpp SatBinomConsumer.cpp		\
  SatBinomRecorder.cpp CountingIOHandler.cpp test/TestSorter.cpp		\
  DimensionAction.cpp SizeMaxIndepSetAlg.cpp TaskEngine.cpp Task.cpp	\
  BigattiHilbertAlgorithm.cpp BigattiState.cpp ObjectCache.cpp			\
  HashPolynomial.cpp BigattiBaseCase.cpp BigattiPivotStrategy.cpp		\
  BigattiFacade.cpp UniHashPolynomial.cpp CommonParams.cpp				\
  CliParams.cpp SliceParams.cpp SliceLikeParams.cpp BigattiParams.cpp	\
  IOHandlerImpl.cpp IdealWriter.cpp PolyWriter.cpp IOHandlerCommon.cpp	\
  CommonParamsHelper.cpp ActionPrinter.cpp ScarfHilbertAlgorithm.cpp	\
  ScarfFacade.cpp Deformer.cpp IdealTree.cpp TermPredicate.cpp			\
  ScarfParams.cpp IdealOrderer.cpp TermExtra.cpp display.cpp			\
  Matrix.cpp BigIntVector.cpp ColumnPrinter.cpp EulerAction.cpp			\
  RawSquareFreeTerm.cpp RawSquareFreeIdeal.cpp PivotEulerAlg.cpp		\
  EulerState.cpp PivotStrategy.cpp Arena.cpp LocalArray.cpp				\
  LatticeAlgs.cpp InputConsumer.cpp SquareFreeIdeal.cpp

rawTests := LibAlexanderDualTest.cpp LibHilbertPoincareTest.cpp			\
  LibIrreducibleDecomTest.cpp LibMaxStdTest.cpp LibStdProgramTest.cpp	\
  LibTest.cpp OptimizeStrategyTest.cpp TermTest.cpp						\
  TermTranslatorTest.cpp RawSquareFreeTermTest.cpp						\
  RawSquareFreeIdealTest.cpp LibPrimaryDecomTest.cpp					\
  LibAssociatedPrimesTest.cpp MatrixTest.cpp IdealTest.cpp				\
  LibDimensionTest.cpp TermGraderTest.cpp ArenaTest.cpp

ifndef CXX
  CXX      = "g++"
endif

cxxflags = $(CXXFLAGS) $(CPPFLAGS) -I $(GMP_INC_DIR) -Wno-uninitialized -Wno-unused-parameter
program = frobby
library = libfrobby.a
benchArgs = $(FROBBYARGS)

ifndef MODE
 MODE=release
endif

ifndef ldflags
  ldflags = $(LDFLAGS) -lgmpxx -lgmp
endif

MATCH=false
ifeq ($(MODE), release)
  outdir = bin/release/
  cxxflags += -O2
  MATCH=true
endif
ifeq ($(MODE), debug)
  rawSources := $(rawSources) $(rawTests)
  outdir = bin/debug/
  cxxflags += -g -D DEBUG -fno-inline -Werror -Wextra -Wno-uninitialized \
            -Wno-unused-parameter
  MATCH=true
endif
ifeq ($(MODE), shared)
  outdir = bin/shared/
  cxxflags += -O2 -fPIC
  library = libfrobby.so
  MATCH=true
endif
ifeq ($(MODE), profile)
  outdir = bin/profile/
  cxxflags += -g -pg -O2 -D PROFILE
  ldflags += -pg
  MATCH=true
  benchArgs = _profile $(FROBBYARGS)
endif
ifeq ($(MODE), analysis)
  rawSources := $(rawSources) $(rawTests)
  outdir = bin/analysis/
  cxxflags += -Wextra -fsyntax-only -O1 -Wfloat-equal -Wundef			\
      -Wno-endif-labels -Wshadow -Wlarger-than-1000 -Wpointer-arith		\
      -Wcast-qual -Wcast-align -Wwrite-strings -Wconversion -Wsign-compare	\
      -Waggregate-return -Wmissing-noreturn -Wmissing-format-attribute		\
      -Wno-multichar -Wno-deprecated-declarations -Wpacked			\
      -Wno-redundant-decls -Wunreachable-code -Winline				\
      -Wno-invalid-offsetof -Winvalid-pch -Wlong-long				\
      -Wdisabled-optimization -D DEBUG -Werror
  MATCH=true
endif

ifeq ($(MATCH), false)
  $(error Unknown value of MODE: "$(MODE)")
endif

sources = $(patsubst %.cpp, src/%.cpp, $(rawSources))
objs    = $(patsubst %.cpp, $(outdir)%.o, $(rawSources))

RANLIB = ranlib

# ***** Compilation

.PHONY: all depend clean bin/$(program) test library distribution clear fixspace

all: bin/$(program) $(outdir)$(program)

# ****************** Testing
# use TESTARGS of
#  _valgrind to run under valgrind.
#  _debugAlloc to test recovery when running out of memory.
#  _full to obtain extra tests by verifying relations
#    between outputs of different actions, and generally testing
#    everything that can be tested.
# _full cannot follow the other options because it is picked up at an earlier
# point in the test system than they are. There are more options - see
# test/testScripts/testhelper for a full list.
#
# Only miniTest and bareTest support TESTARGS, and some options are not
# available unless MODE=debug.

# The correct choice to do a reasonably thorough test of an
# installation of Frobby.
test: all
	test/runTests

# Run all tests that it makes sense to run.
fullTest: all
	test/runTests _full
	test/runSplitTests _full

# Good for testing Frobby after a small change.
microTest: all
	test/runTests _few $(TESTARGS)
miniTest: all
	test/runTests $(TESTARGS)

# Runs all tests and allows full control over the arguments.
bareTest: all
	test/runTests $(TESTARGS) 
	test/runSplitTests $(TESTARGS)

# Run benchmarks to detect performance regressions. When MODE=profile,
# profile files for the benchmarked actions will be placed in bin/.
bench: all
	cd test/bench; ./runbench $(benchArgs)
benchHilbert: all
	cd test/bench; ./run_hilbert_bench $(benchArgs)
benchOptimize: all
	cd test/bench; ./run_optimize_bench $(benchArgs)
benchAlexdual: all
	cd test/bench; ./run_alexdual_bench $(benchArgs)

bin/:
	mkdir bin/;

# Make symbolic link to program from bin/
bin/$(program): $(outdir)$(program) bin/
ifneq ($(MODE), analysis)
	cd bin; rm -f $(program); ln -s ../$(outdir)$(program) $(program); cd ..
endif

# Link object files into executable
$(outdir)$(program): $(objs) | $(outdir)
	@mkdir -p $(dir $@)
ifeq ($(MODE), analysis)
	echo > $@
endif
ifneq ($(MODE), analysis)
	$(CXX) $(objs) $(ldflags) -o $@
	if [ -f $@.exe ]; then \
      mv -f $@.exe $@; \
	fi
endif
ifeq ($(MODE), release)
	strip $@
endif

# Link object files into library
library: bin/$(library)
bin/$(library): $(objs) | bin/
	rm -f bin/$(library)
ifeq ($(MODE), shared)
	$(CXX) -shared -Wl,-soname,$(library).$(FROBBY_SOVERSION) \
	-o bin/$(library).$(FROBBY_VERSION) $(ldflags) \
	  $(patsubst $(outdir)main.o,,$(objs)) -lgmp -lgmpxx
else
	ar crs bin/$(library) $(patsubst $(outdir)main.o,,$(objs))
	$(RANLIB) bin/$(library)
endif

# Compile and output object files.
# In analysis mode no file is created, so create one
# to allow dependency analysis to work.
$(outdir)%.o: src/%.cpp
	@mkdir -p $(dir $@)
	$(CXX) ${cxxflags} -c $< -o $@
	$(CXX) $(cxxflags) -MM -c $< > $(@:.o=.d).tmp
# using /usr/bin/env echo to get the non-built-in echo on OS X, since
# the built-in one does not understand the parameter -n.
	@/usr/bin/env echo -n "$(dir $@)" > $(@:.o=.d)
	@cat $(@:.o=.d).tmp >> $(@:.o=.d)
	@sed -e 's/.*://' -e 's/\\$$//' < $(@:.o=.d).tmp | fmt -1 | \
	  sed -e 's/^ *//' -e 's/$$/:/' >> $(@:.o=.d)
	@rm -f $(@:.o=.d).tmp
ifeq ($(MODE), analysis)
	  echo > $@
endif

-include $(objs:.o=.d)

PREFIX ?= /usr/local
BINDIR ?= $(PREFIX)/bin
MAN1DIR ?= $(PREFIX)/share/man/man1
LIBDIR ?= $(PREFIX)/lib

# Installation.
install:
ifneq ($(wildcard bin/frobby),)
	install -d $(DESTDIR)$(BINDIR)
	install bin/frobby $(DESTDIR)$(BINDIR)
	mkdir -p $(DESTDIR)$(MAN1DIR)
	install -m 644 doc/frobby.1 $(DESTDIR)$(MAN1DIR)
endif
ifneq ($(wildcard bin/libfrobby*),)
	install -d $(DESTDIR)$(LIBDIR)
ifneq ($(wildcard bin/libfrobby.a),)
	install bin/libfrobby.a $(DESTDIR)$(LIBDIR)
endif
ifneq ($(wildcard bin/libfrobby.so.$(FROBBY_VERSION)),)
	install bin/libfrobby.so.$(FROBBY_VERSION) $(DESTDIR)$(LIBDIR)
	cd $(DESTDIR)$(LIBDIR) && \
		rm -f libfrobby.so.$(FROBBY_SOVERSION) && \
		ln -s libfrobby.so.$(FROBBY_VERSION) \
			libfrobby.so.$(FROBBY_SOVERSION) && \
		rm -f libfrobby.so && \
		ln -s libfrobby.so.$(FROBBY_VERSION) libfrobby.so
endif
endif

# ***** Documentation

# We need to run latex three times to make sure that references are done
# properly in the output.
doc: docPs docPdf
docPs:
	rm -rf bin/doc
	mkdir bin/doc
	for i in 1 2 3; do latex -output-directory=bin/doc/ doc/manual.tex; done
	cd bin; dvips doc/manual.dvi
docPdf:
	rm -rf bin/doc
	mkdir bin/doc
	for i in 1 2 3; do pdflatex -output-directory=bin/doc/ doc/manual.tex; done
	mv bin/doc/manual.pdf bin
docDviOnce: # Useful to view changes when writing the manual
	latex -output-directory=bin/doc doc/manual.tex

# It may seem wasteful to run doxygen three times to generate three
# kinds of output. However, the latex output for creating a pdf file
# and for creating a PostScript file is different, and so at least two
# runs are necessary. Making the HTML output a third run is cleaner
# than tacking it onto one or both of the other two targets.
bin/develDoc/: bin/
	mkdir bin/develDoc
develDoc: develDocHtml develDocPdf develDocPs
develDocHtml: bin/develDoc/
	cat doc/doxygen.conf doc/doxHtml|doxygen -
develDocPdf: bin/develDoc/
	rm -rf bin/develDoc/latexPdf bin/develDoc/warningLog
	cat doc/doxygen.conf doc/doxPdf|doxygen -
	cd bin/develDoc/latexPdf; for f in `ls *.eps`; do epstopdf $$f; done # Cygwin fix
	cd bin/develDoc/latexPdf/; make refman.pdf; mv refman.pdf ../develDoc.pdf
develDocPs: bin/develDoc/
	rm -rf bin/develDoc/latexPs bin/develDoc/warningLog
	cat doc/doxygen.conf doc/doxPs|doxygen -
	cd bin/develDoc/latexPs/; make refman.ps; mv refman.ps ../develDoc.ps

clean: tidy
	rm -rf bin

# ***** Miscellaneous

tidy:

=== debian/changelog ===
frobby (0.9.6-1~exp1) experimental; urgency=medium

  * New upstream release.
    - API change; constants::version is now frobby_version.  (This actually
      occurred in 0.9.5, but without a soversion bump, so we patched it
      back to the old behavior in Debian.)
  * Rename libfrobby0 binary package to libfrobby1 due to soversion bump.
  * Upload to experimental ahead of libfrobby0 -> libfrobby1 transition.
  * debian/control
    - Update my email address; now a Debian Developer.
    - Bump Standards-Version to 4.7.2
    - Drop dependency on g++; we only had it to guarantee GCC at least 7,
      but GCC 10 is now in oldoldstable.
    - Remove redundant Rules-Requires-Root field.
  * debian/copyright
    - Update my copyright years and email address.
  * debian/frobby.manpages
    - Update path to manpage.
  * debian/gbp.conf
    - New file; set debian-branch to debian/latest and pristine-tar to True.
  * debian/libfrobby*.install
    - Update paths now that dh_auto_install installs everything in the
      proper place.
  * debian/patches/frobby-version.patch
    - Remove patch; no longer necessary since upstream has properly bumped
      the soversion.
  * debian/rules
    - Drop override_dh_link target as shared library symlinks are now created
      by the upstream Makefile.
    - Stop setting RANLIB variable; now set in upstream Makefile.
    - Stop setting library name and soname; now taken care of in upstream
      Makefile.
    - Stop setting BIN_INSTALL_DIR; no longer used;
    - Export PREFIX and LIBDIR so that dh_auto_install will install
      everything in the right places.
  * debian/tests/frobby-version.cpp
    - Update to use frobby_version.

 -- Doug Torrance <dtorrance@debian.org>  Mon, 22 Dec 2025 11:21:43 -0500

=== debian/control ===
Source: frobby
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Section: math
Priority: optional
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch: libgmp-dev, texlive-latex-base
Build-Depends-Indep: doxygen
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/math-team/frobby
Vcs-Git: https://salsa.debian.org/math-team/frobby.git
Homepage: https://github.com/Macaulay2/frobby

Package: frobby
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: 4ti2
Description: Computations with monomial ideals
 Frobby is a software system and project for computations with monomial ideals.
 Frobby is free software and it is intended as a vehicle for computational and
 mathematical research on monomial ideals.
 .
 The current functionality includes Euler characteristic, Hilbert series,
 maximal standard monomials, combinatorial optimization on monomial ideals,
 primary decomposition, irreducible decomposition, Alexander dual, associated
 primes, minimization and intersection of monomial ideals as well as the
 computation of Frobenius problems (using 4ti2) with very mmlarge numbers.
 Frobby is also able to translate between formats that can be used with several
 different computer systems, such as Macaulay 2, Monos, 4ti2, CoCoA4 and
 Singular. Thus Frobby can be used with any of those systems.

Package: libfrobby1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Computations with monomial ideals (shared library)
 Frobby is a software system and project for computations with monomial ideals.
 Frobby is free software and it is intended as a vehicle for computational and
 mathematical research on monomial ideals.
 .
 The current functionality includes Euler characteristic, Hilbert series,
 maximal standard monomials, combinatorial optimization on monomial ideals,
 primary decomposition, irreducible decomposition, Alexander dual, associated
 primes, minimization and intersection of monomial ideals as well as the
 computation of Frobenius problems (using 4ti2) with very large numbers. Frobby
 is also able to translate between formats that can be used with several
 different computer systems, such as Macaulay 2, Monos, 4ti2, CoCoA4 and
 Singular. Thus Frobby can be used with any of those systems.
 .
 This package contains the shared library.

Package: libfrobby-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libfrobby1 (=${binary:Version}), libgmp-dev, ${misc:Depends}
Recommends: libfrobby-doc (=${binary:Version})
Description: Computations with monomial ideals (development tools)
 Frobby is a software system and project for computations with monomial ideals.
 Frobby is free software and it is intended as a vehicle for computational and
 mathematical research on monomial ideals.
 .
 The current functionality includes Euler characteristic, Hilbert series,
 maximal standard monomials, combinatorial optimization on monomial ideals,
 primary decomposition, irreducible decomposition, Alexander dual, associated
 primes, minimization and intersection of monomial ideals as well as the
 computation of Frobenius problems (using 4ti2) with very large numbers. Frobby
 is also able to translate between formats that can be used with several
 different computer systems, such as Macaulay 2, Monos, 4ti2, CoCoA4 and
 Singular. Thus Frobby can be used with any of those systems.
 .
 This package contains the development tools.

Package: libfrobby-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Computations with monomial ideals (library documentation)
 Frobby is a software system and project for computations with monomial ideals.
 Frobby is free software and it is intended as a vehicle for computational and
 mathematical research on monomial ideals.
 .
 The current functionality includes Euler characteristic, Hilbert series,
 maximal standard monomials, combinatorial optimization on monomial ideals,
 primary decomposition, irreducible decomposition, Alexander dual, associated
 primes, minimization and intersection of monomial ideals as well as the
 computation of Frobenius problems (using 4ti2) with very large numbers. Frobby
 is also able to translate between formats that can be used with several
 different computer systems, such as Macaulay 2, Monos, 4ti2, CoCoA4 and
 Singular. Thus Frobby can be used with any of those systems.
 .
 This package contains the library documentation.

## frobby 0.9.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-project(frobby VERSION 0.9.6 LANGUAGES CXX)
+project(frobby VERSION 0.9.7 LANGUAGES CXX)
 
 set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # bump if interfaces added, removed, or changed
 FROBBY_CURRENT = 1
 # bump at every release, set to 0 if any interfaces added, removed, or changed
-FROBBY_REVISION = 1
+FROBBY_REVISION = 2
 # bump if interfaces added, set to 0 if removed or changed
 FROBBY_AGE = 0
 FROBBY_SOVERSION := $(shell expr $(FROBBY_CURRENT) - $(FROBBY_AGE))
@@ -86,6 +86,9 @@
 ifndef CXX
   CXX      = "g++"
 endif
+ifndef STRIP
+  STRIP    = strip
+endif
 
 cxxflags = $(CXXFLAGS) $(CPPFLAGS) -I $(GMP_INC_DIR) -Wno-uninitialized -Wno-unused-parameter
 program = frobby
@@ -223,7 +226,7 @@
 	fi
 endif
 ifeq ($(MODE), release)
-	strip $@
+	$(STRIP) $@
 endif
 
 # Link object files into library
@@ -263,6 +266,7 @@
 BINDIR ?= $(PREFIX)/bin
 MAN1DIR ?= $(PREFIX)/share/man/man1
 LIBDIR ?= $(PREFIX)/lib
+INCLUDEDIR ?= $(PREFIX)/include
 
 # Installation.
 install:
@@ -274,6 +278,8 @@
 endif
 ifneq ($(wildcard bin/libfrobby*),)
 	install -d $(DESTDIR)$(LIBDIR)
+	install -d $(DESTDIR)$(INCLUDEDIR)
+	install src/frobby.h $(DESTDIR)$(INCLUDEDIR)
 ifneq ($(wildcard bin/libfrobby.a),)
 	install bin/libfrobby.a $(DESTDIR)$(LIBDIR)
 endif
@@ -324,11 +330,3 @@
 develDocPs: bin/develDoc/
 	rm -rf bin/develDoc/latexPs bin/develDoc/warningLog
 	cat doc/doxygen.conf doc/doxPs|doxygen -
-	cd bin/develDoc/latexPs/; make refman.ps; mv refman.ps ../develDoc.ps
-
-clean: tidy
-	rm -rf bin
-
-# ***** Miscellaneous
-
-tidy:

=== debian/changelog ===
frobby (0.9.7-1) unstable; urgency=medium

  * New upstream release.

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #1125147)
    + Let dh_auto_build pass cross tools to make.
    + Don't strip during build.

  [ Doug Torrance ]
  * debian/copyright
    - Update my copyright years.
  * debian/libfrobby-dev.install
    - Simplify installation of header file now that upstream installs it
      for us.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 09 Jan 2026 15:07:27 -0500

frobby (0.9.6-1) unstable; urgency=medium

  * Upload to unstable for libfrobby0 -> libfrobby1 transition.
  * debian/control
    - Drop Priority field; "optional" is now the default.
    - Bump Standards-Version to 4.7.3.

 -- Doug Torrance <dtorrance@debian.org>  Sun, 28 Dec 2025 07:37:53 -0500

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,10 @@
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Doug Torrance <dtorrance@debian.org>
 Section: math
-Priority: optional
 Build-Depends: debhelper-compat (= 13)
 Build-Depends-Arch: libgmp-dev, texlive-latex-base
 Build-Depends-Indep: doxygen
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/math-team/frobby
 Vcs-Git: https://salsa.debian.org/math-team/frobby.git
 Homepage: https://github.com/Macaulay2/frobby

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk # for DEB_HOST_MULTIARCH

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PREFIX = /usr
export LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)

# for reproducible builds of manual
export FORCE_SOURCE_DATE = 1

%:
	dh $@ --no-parallel --buildsystem=makefile

override_dh_auto_build-arch:
	dh_auto_build -- all STRIP=:
	dh_auto_build -- library
	dh_auto_build -- library MODE=shared
	dh_auto_build -- docPdf

override_dh_auto_build-indep:
	dh_auto_build -- develDocHtml

override_dh_auto_test-indep override_dh_auto_install-indep:

override_dh_installdocs:
	dh_installdocs -X/_formulas.
